Do not blow up when another puppet process is already running during deploy.
[arvados-dev.git] / jenkins / run-tests.sh
index 0d89dcff7b75f1883db3cc67f453df86b0454c18..40a6daa0363c2643622114e769122ab7a61a4700 100755 (executable)
@@ -1,25 +1,97 @@
 #!/bin/bash
 
-# Install and test Arvados components.
-#
-# Exit non-zero if any tests fail.
-#
-# Arguments:
-# --skip FOO   Do not test the FOO component.
-# --only FOO   Do not test anything except the FOO component.
-#
-# Regardless of which components are tested, install all components in
-# the usual sequence. (Many test suites depend on other components
-# being installed.)
+read -rd "\000" helpmessage <<EOF
+$(basename $0): Install and test Arvados components.
+
+Exit non-zero if any tests fail.
+
+Syntax:
+        $(basename $0) WORKSPACE=/path/to/arvados [options]
+
+Options:
+
+--skip FOO     Do not test the FOO component.
+--only FOO     Do not test anything except the FOO component.
+--leave-temp   Do not remove GOPATH, virtualenv, and other temp dirs at exit.
+               Instead, show which directories were used this time so they
+               can be reused in subsequent invocations.
+--skip-install Do not run any install steps. Just run tests.
+               You should provide GOPATH, GEMHOME, and VENVDIR options
+               from a previous invocation if you use this option.
+WORKSPACE=path Arvados source tree to test.
+CONFIGSRC=path Dir with api server config files to copy into source tree.
+               (If none given, leave config files alone in source tree.)
+apiserver_test="TEST=test/functional/arvados/v1/collections_controller_test.rb"
+               Restrict apiserver tests to the given file
+python_sdk_test="--test-suite test.test_keep_locator"
+               Restrict Python SDK tests to the given class
+workbench_test="TEST=test/integration/pipeline_instances_test.rb"
+               Restrict Workbench tests to the given file
+ARVADOS_DEBUG=1
+               Print more debug messages
+envvar=value   Set \$envvar to value. Primarily useful for WORKSPACE,
+               *_test, and other examples shown above.
+
+Assuming --skip-install is not given, all components are installed
+into \$GOPATH, \$VENDIR, and \$GEMHOME before running any tests. Many
+test suites depend on other components being installed, and installing
+everything tends to be quicker than debugging dependencies.
+
+As a special concession to the current CI server config, CONFIGSRC
+defaults to $HOME/arvados-api-server if that directory exists.
+
+More information and background:
+
+https://arvados.org/projects/arvados/wiki/Running_tests
+EOF
+
+# First make sure to remove any ARVADOS_ variables from the calling
+# environment that could interfere with the tests.
+unset $(env | cut -d= -f1 | grep \^ARVADOS_)
+
+# Reset other variables that could affect our [tests'] behavior by
+# accident.
+GITDIR=
+GOPATH=
+VENVDIR=
+PYTHONPATH=
+GEMHOME=
 
 COLUMNS=80
 
-ARVADOS_API_HOST=qr1hi.arvadosapi.com
+cli_test=
+workbench_test=
+apiserver_test=
+python_sdk_test=
+ruby_sdk_test=
+fuse_test=
+leave_temp=
+skip_install=
 
-export GOPATH=$(mktemp -d)
-VENVDIR=$(mktemp -d)
+if [[ -f /etc/profile.d/rvm.sh ]]
+then
+    source /etc/profile.d/rvm.sh
+fi
 
-source /etc/profile.d/rvm.sh
+declare -A leave_temp
+clear_temp() {
+    leaving=""
+    for var in VENVDIR GOPATH GITDIR GEMHOME
+    do
+        if [[ -z "${leave_temp[$var]}" ]]
+        then
+            if [[ -n "${!var}" ]]
+            then
+                rm -rf "${!var}"
+            fi
+        else
+            leaving+=" $var=\"${!var}\""
+        fi
+    done
+    if [[ -n "$leaving" ]]; then
+        echo "Leaving behind temp dirs: $leaving"
+    fi
+}
 
 fatal() {
     clear_temp
@@ -27,18 +99,23 @@ fatal() {
     exit 1
 }
 
-# Sanity check
-echo "WORKSPACE=$WORKSPACE"
-[[ -n "$WORKSPACE" ]] || fatal "WORKSPACE not set"
-
-# Set up temporary install dirs
-mkdir -p "$GOPATH/src/git.curoverse.com"
-ln -sfn "$WORKSPACE" "$GOPATH/src/git.curoverse.com/arvados.git" \
-    || fatal "symlink failed"
-
-virtualenv --setuptools "$VENVDIR" || fatal "virtualenv $VENVDIR failed"
-PATH="$VENVDIR/bin:$PATH"
+report_outcomes() {
+    for x in "${successes[@]}"
+    do
+        echo "Pass: $x"
+    done
 
+    if [[ ${#failures[@]} == 0 ]]
+    then
+        echo "All test suites passed."
+    else
+        echo "Failures (${#failures[@]}):"
+        for x in "${failures[@]}"
+        do
+            echo "Fail: $x"
+        done
+    fi
+}
 declare -a failures
 declare -A skip
 
@@ -49,6 +126,11 @@ while [[ -n "$1" ]]
 do
     arg="$1"; shift
     case "$arg" in
+        --help)
+            echo >&2 "$helpmessage"
+            echo >&2
+            exit 1
+            ;;
         --skip)
             skipwhat="$1"; shift
             skip[$skipwhat]=1
@@ -56,13 +138,55 @@ do
         --only)
             only="$1"; shift
             ;;
+        --skip-install)
+            skip_install=1
+            ;;
+        --leave-temp)
+            leave_temp[VENVDIR]=1
+            leave_temp[GOPATH]=1
+            leave_temp[GEMHOME]=1
+            ;;
+        *=*)
+            eval export $(echo $arg | cut -d= -f1)=\"$(echo $arg | cut -d= -f2-)\"
+            ;;
         *)
-            echo >&2 "$0: Unrecognized option: '$arg'"
+            echo >&2 "$0: Unrecognized option: '$arg'. Try: $0 --help"
             exit 1
             ;;
     esac
 done
 
+# Sanity check
+echo "WORKSPACE=$WORKSPACE"
+[[ -n "$WORKSPACE" ]] || fatal "WORKSPACE not set"
+
+if [[ -z "$CONFIGSRC" ]] && [[ -d "$HOME/arvados-api-server" ]]; then
+    # Jenkins expects us to use this by default.
+    CONFIGSRC="$HOME/arvados-api-server"
+fi
+
+# Clean up .pyc files that may exist in the workspace
+cd "$WORKSPACE"
+find -name '*.pyc' -delete
+
+# Set up temporary install dirs (unless existing dirs were supplied)
+for tmpdir in VENVDIR GOPATH GEMHOME
+do
+    if [[ -n "${!tmpdir}" ]]; then
+        leave_temp[$tmpdir]=1
+    else
+        eval $tmpdir=$(mktemp -d)
+    fi
+done
+PATH="$GEMHOME/.gem/ruby/2.1.0/bin:$PATH"
+export GOPATH
+mkdir -p "$GOPATH/src/git.curoverse.com"
+ln -sfn "$WORKSPACE" "$GOPATH/src/git.curoverse.com/arvados.git" \
+    || fatal "symlink failed"
+
+virtualenv --setuptools "$VENVDIR" || fatal "virtualenv $VENVDIR failed"
+. "$VENVDIR/bin/activate"
+
 checkexit() {
     if [[ "$?" != "0" ]]; then
         title "!!!!!! $1 FAILED !!!!!!"
@@ -99,16 +223,21 @@ do_test() {
 }
 
 do_install() {
-    title "Running $1 install"
-    timer_reset
-    if [[ "$2" == "go" ]]
+    if [[ -z "$skip_install" ]]
     then
-        go get -t "git.curoverse.com/arvados.git/$1"
+        title "Running $1 install"
+        timer_reset
+        if [[ "$2" == "go" ]]
+        then
+            go get -t "git.curoverse.com/arvados.git/$1"
+        else
+            "install_$1"
+        fi
+        checkexit "$1 install"
+        title "End of $1 install (`timer`)"
     else
-        "install_$1"
+        title "Skipping $1 install"
     fi
-    checkexit "$1 install"
-    title "End of $1 install (`timer`)"
 }
 
 title () {
@@ -116,40 +245,67 @@ title () {
     printf "\n%*s%s\n\n" $((($COLUMNS-${#txt})/2)) "" "$txt"
 }
 
-clear_temp() {
-    for t in "$VENVDIR" "$GOPATH"
-    do
-        if [[ -n "$t" ]]
-        then
-            rm -rf "$t"
-        fi
-    done
-}
-
 install_docs() {
     cd "$WORKSPACE/doc"
-    bundle install --deployment
+    HOME="$GEMHOME" bundle install --no-deployment
     rm -rf .site
     # Make sure python-epydoc is installed or the next line won't do much good!
-    PYTHONPATH=$WORKSPACE/sdk/python/ bundle exec rake generate baseurl=file://$WORKSPACE/doc/.site/ arvados_workbench_host=workbench.$ARVADOS_API_HOST arvados_api_host=$ARVADOS_API_HOST
+    ARVADOS_API_HOST=qr1hi.arvadosapi.com
+    PYTHONPATH=$WORKSPACE/sdk/python/ HOME="$GEMHOME" bundle exec rake generate baseurl=file://$WORKSPACE/doc/.site/ arvados_workbench_host=workbench.$ARVADOS_API_HOST arvados_api_host=$ARVADOS_API_HOST
+    unset ARVADOS_API_HOST
 }
 do_install docs
 
-test_doclinkchecker() {
-    cd "$WORKSPACE/doc"
-    bundle exec rake linkchecker baseurl=file://$WORKSPACE/doc/.site/
+install_ruby_sdk() {
+    cd "$WORKSPACE/sdk/ruby" \
+        && HOME="$GEMHOME" bundle install --no-deployment \
+        && gem build arvados.gemspec \
+        && HOME="$GEMHOME" gem install --user-install --no-ri --no-rdoc `ls -t arvados-*.gem|head -n1`
 }
-do_test doclinkchecker
+do_install ruby_sdk
+
+install_cli() {
+    cd "$WORKSPACE/sdk/cli" \
+        && gem build arvados-cli.gemspec \
+        && HOME="$GEMHOME" gem install --user-install --no-ri --no-rdoc `ls -t arvados-cli-*.gem|head -n1`
+}
+do_install cli
+
+install_python_sdk() {
+    # Install the Python SDK early. Various other test suites (like
+    # keepproxy) bring up run_test_server.py, which imports the arvados
+    # module. We can't actually *test* the Python SDK yet though, because
+    # its own test suite brings up some of those other programs (like
+    # keepproxy).
+
+    cd "$WORKSPACE/sdk/python" \
+        && python setup.py sdist rotate --keep=1 --match .tar.gz \
+        && pip install dist/arvados-python-client-0.1.*.tar.gz
+}
+do_install python_sdk
+
+install_fuse() {
+    cd "$WORKSPACE/services/fuse" \
+        && python setup.py sdist rotate --keep=1 --match .tar.gz \
+        && pip install dist/arvados_fuse-0.1.*.tar.gz
+}
+do_install fuse
 
 install_apiserver() {
     cd "$WORKSPACE/services/api"
-    bundle install --deployment
+    export RAILS_ENV=test
+    HOME="$GEMHOME" bundle install --no-deployment
 
     rm -f config/environments/test.rb
     cp config/environments/test.rb.example config/environments/test.rb
 
-    cp $HOME/arvados-api-server/database.yml config/ || fatal "database.yml"
-    cp $HOME/arvados-api-server/application.yml config/ || fatal "application.yml"
+    if [ -n "$CONFIGSRC" ]
+    then
+        for f in database.yml application.yml
+        do
+            cp "$CONFIGSRC/$f" config/ || fatal "$f"
+        done
+    fi
 
     # Fill in a random secret_token and blob_signing_key for testing
     SECRET_TOKEN=`echo 'puts rand(2**512).to_s(36)' |ruby`
@@ -158,10 +314,8 @@ install_apiserver() {
     sed -i'' -e "s:SECRET_TOKEN:$SECRET_TOKEN:" config/application.yml
     sed -i'' -e "s:BLOB_SIGNING_KEY:$BLOB_SIGNING_KEY:" config/application.yml
 
-    export RAILS_ENV=test
-
     # Set up empty git repo (for git tests)
-    GITDIR="$WORKSPACE/tmpgit"
+    GITDIR=$(mktemp -d)
     sed -i'' -e "s:/var/cache/git:$GITDIR:" config/application.default.yml
 
     rm -rf $GITDIR
@@ -174,27 +328,20 @@ install_apiserver() {
         && git add tmp \
         && git commit -m 'initial commit'
 
+    # Clear out any lingering postgresql connections to arvados_test, so that we can drop it
+    # This assumes the current user is a postgresql superuser
+    psql arvados_test -c "SELECT pg_terminate_backend (pg_stat_activity.procpid::int) FROM pg_stat_activity WHERE pg_stat_activity.datname = 'arvados_test';" 2>/dev/null
+
     cd "$WORKSPACE/services/api" \
-        && bundle exec rake db:drop \
-        && bundle exec rake db:create \
-        && bundle exec rake db:setup
+        && HOME="$GEMHOME" bundle exec rake db:drop \
+        && HOME="$GEMHOME" bundle exec rake db:create \
+        && HOME="$GEMHOME" bundle exec rake db:setup
 }
 do_install apiserver
 
-test_apiserver() {
-    cd "$WORKSPACE/services/api"
-    bundle exec rake test
-}
-do_test apiserver
-
-install_cli() {
-    cd "$WORKSPACE/sdk/cli"
-    bundle install --deployment
-}
-do_install cli
-
 declare -a gostuff
 gostuff=(
+    services/crunchstat
     services/keepstore
     services/keepproxy
     sdk/go/arvadosclient
@@ -206,25 +353,33 @@ do
     do_install "$g" go
 done
 
-install_python_sdk() {
-    # Install the Python SDK early. Various other test suites (like
-    # keepproxy) bring up run_test_server.py, which imports the arvados
-    # module. We can't actually *test* the Python SDK yet though, because
-    # its own test suite brings up some of those other programs (like
-    # keepproxy).
+test_doclinkchecker() {
+    cd "$WORKSPACE/doc"
+    HOME="$GEMHOME" bundle exec rake linkchecker baseurl=file://$WORKSPACE/doc/.site/
+}
+do_test doclinkchecker
 
-    cd "$WORKSPACE/sdk/python" \
-        && python setup.py egg_info -b ".$(git log --format=format:%ct.%h -n1 .)" sdist rotate --keep=1 --match .tar.gz \
-        && pip install dist/arvados-python-client-0.1.*.tar.gz
+test_ruby_sdk() {
+    cd "$WORKSPACE/sdk/ruby" \
+        && HOME="$GEMHOME" bundle install --no-deployment \
+        && HOME="$GEMHOME" bundle exec rake test
 }
-do_install python_sdk
+do_test ruby_sdk
 
-test_fuse() {
-    cd "$WORKSPACE/services/fuse" \
-        && python setup.py egg_info -b ".$(git log --format=format:%ct.%h -n1 .)" sdist rotate --keep=1 --match .tar.gz \
-        && pip install dist/arvados_fuse-0.1.*.tar.gz
+test_cli() {
+    title "Starting SDK CLI tests"
+    cd "$WORKSPACE/sdk/cli" \
+        && HOME="$GEMHOME" bundle install --no-deployment \
+        && mkdir -p /tmp/keep \
+        && KEEP_LOCAL_STORE=/tmp/keep HOME="$GEMHOME" bundle exec rake test $cli_test
 }
-do_test fuse
+do_test cli
+
+test_apiserver() {
+    cd "$WORKSPACE/services/api"
+    HOME="$GEMHOME" bundle exec rake test $apiserver_test
+}
+do_test apiserver
 
 test_python_sdk() {
     # Python SDK. We test this before testing keepproxy: keepproxy runs
@@ -234,18 +389,27 @@ test_python_sdk() {
     # the .egg files that setup.py downloads.
 
     cd "$WORKSPACE/sdk/python" \
-        && python setup.py test \
-        && easy_install *.egg
+        && python setup.py test $python_sdk_test
+    r=$?
+    easy_install *.egg
+    return $r
 }
 do_test python_sdk
 
-install_fuse() {
+test_fuse() {
     # Install test dependencies here too, in case run_test_server needs them.
     cd "$WORKSPACE/services/fuse" \
-        && python setup.py test \
-        && easy_install *.egg
+        && python setup.py test $fuse_test
+    r=$?
+    easy_install *.egg
+    return $r
 }
-do_install fuse
+do_test fuse
+
+test_nodemanager() {
+    cd "$WORKSPACE/services/nodemanager" && python setup.py test
+}
+do_test nodemanager
 
 for g in "${gostuff[@]}"
 do
@@ -254,35 +418,12 @@ done
 
 test_workbench() {
     cd "$WORKSPACE/apps/workbench" \
-        && bundle install --deployment \
-        && bundle exec rake test
+        && HOME="$GEMHOME" bundle install --no-deployment \
+        && HOME="$GEMHOME" bundle exec rake test $workbench_test
 }
 do_test workbench
 
-test_cli() {
-    title "Starting SDK CLI tests"
-    cd "$WORKSPACE/sdk/cli" \
-        && bundle install --deployment \
-        && mkdir -p /tmp/keep \
-        && KEEP_LOCAL_STORE=/tmp/keep bundle exec rake test
-}
-do_test cli
-
+report_outcomes
 clear_temp
 
-for x in "${successes[@]}"
-do
-    echo "Pass: $x"
-done
-
-if [[ ${#failures[@]} == 0 ]]
-then
-    echo "All test suites passed."
-else
-    echo "Failures (${#failures[@]}):"
-    for x in "${failures[@]}"
-    do
-        echo "Fail: $x"
-    done
-fi
 exit ${#failures}